﻿#SingleInstance Force
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#Include %A_ScriptDir%/resources/include/TTS.ahk

Global ShowDebug := 0


global Version := "1.5.0"
global IniFile := "NippysFishBot.ini" ;Save Filename
global FolderPathToResources := A_ScriptDir . "\Resources\"
global FolderPathToSlotConfigImages := A_ScriptDir . "\Resources\InvSlotConfig\"
global PathToBootDrop := A_ScriptDir . "\BootDrop.ahk"
global ShowMainUI := 0

global Voice := ComObjCreate("SAPI.SpVoice")
global TTSEnabled := 1                  ;Change to 0 to disable and 1 to enabled.
global BotList := Object()              ;The array where the clients are added.
global ShowGui := 1                     ;v1.2 TO show the Gui or not.

;Fishing bot default settings.global DUpdateURL := "http://ts3.shackx.net/Trove/NippysFishbotp&o.txt" ;Defaul url to update pointers/offsets
global DUpdateURL := "http://ts3.shackx.net/Trove/NippysFishbotp&o.txt" ;Defaul url to update pointers/offsets
global DLastUpdated := "5/22/2016 2:20PM" ; Defailt address.
global DFAddress := "0x00E030CC" ; Defailt address.
global DWaterOffset := "0x8+0xb4+0x28+0x22c"  ;Water bite offset
global DChocoOffset := "0x8+0xb4+0x28+0x488"  ;choco bite offset
global DLavaOffset := "0x8+0xb4+0x28+0x6e8"   ;Lava Bite offset
global DPlasmaOffset := "0x8+0x1c4+0x464+0x460"   ;Plasma Bite offset
global DStateWaterOffset := "0x1bc+0x4+0x748+0x1ec"   ;Water STate offset
global DStateChocoOffset := "0x1bc+0x4+0x748+0x448"   ;choco state offset
global DStateLavaOffset := "0x1bc+0x4+0x690+0x88"     ;Lava state offset
global DStatePlasmaOffset := "0x1bc+0x4+0x430+0x88"     ;Plasma state offset

global DRecastWaitTime := "190-1500"     ;Random recast wait time from what to what
global DReelinWaitTime := "400-1100"      ;This is to change the wait time before reeling in.
global DMemoryScanStart := 8            ;When to start the memoryscan. Lowering can cause cpu lag.
global DMemoryScanTimer := 200           ;Defalt setting for memory scanner to triger.

;Error handling default settings.
global DRetryTimes := 3                  ;How many recast Retrys before seeing the splashScreen.
global DRetryTimesBeforeStoping := 6    ;How many times to try before stoping and add to afk or autoClose?
global DAFKCloseCheck := 1               ;1 = Uses AFK 0 = Close client

;BootDrop Settings.
global DBootDropAfterXSecondsCheck := 0   ;0 Disable 1 Enable
global DBootDropAfterXSeconds := 1200     ;Start Boot drop after X amount of Seconds.
global DBootDropAfterXCastsCheck := 0     ;0 Disable 1 Enable
global DBootDropAfterXCasts := 50         ;Start Boot drop after X amount of casts.
global DBootDropAfterXFishingNotDetectedCheck := 0 ;0 Disable 1 Enable
global DBootDropAfterXFishingNotDetected := 5       ;Start Boot drop after X amount of fishing not detected..
global DBootDropTimeout := 300            ;TheTime out time of bootdorp on said client. If it is within 300Seconds it will not Run again on said client.
global CheckToSeeIfBDRunning := 0        ;Since boot drop can only be ran once if 1 it wont try and Run boot drop till =0
global DDecon := 0        ;Since boot drop can only be ran once if 1 it wont try and Run boot drop till =0

Global AntiAFKRange1 := 60000
Global AntiAFKRange2 := 300000

;	Slots listed by number					1								2								3								4								5								6									7									8									9									10								11								12								13								14								15								16								17								18								19								20								21								22								 23								24								25								26								27								 28								29								30								31								32								33								34								35								36								37								38								39								40								41								42								43								44								 45					
Global DWhichSlotsToDrop := "0x422-430y75-90|0x445-457y75-90|0x472-483y75-90|0x493-508y75-90|0x520-532y75-90|0x422-430y102-113|0x445-457y102-113|0x472-483y102-113|0x493-508y102-113|0x520-532y102-113|0x422-430y127-139|0x445-457y127-139|0x472-483y127-139|0x493-508y127-139|0x520-532y127-139|0x422-430y151-164|0x445-457y151-164|0x472-483y151-164|0x493-508y151-164|0x520-532y151-164|0x422-430y175-187|0x445-457y175-187|0x472-483y175-187|0x493-508y175-187|0x520-532y175-187|0x422-430y199-209|0x445-457y199-209|0x472-483y199-209|0x493-508y199-209|0x520-532y199-209|0x422-430y224-234|0x445-457y224-234|0x472-483y224-234|0x493-508y224-234|0x520-532y244-230|0x422-430y247-260|0x445-457y247-260|0x472-483y247-260|0x493-508y247-260|0x520-532y247-260|0x422-430y273-281|0x445-457y273-281|0x472-483y273-281|0x493-508y273-281|0x520-532y273-281|"
;																		1																																	2																													3																																		4																																	5																																			6																																7																																				8																																	9																																		10																																		11																																	12																																 											13																																																		14																																	15																																		16																																	17																																	18																																		19																																	20																																			21																																	22																																	23																																	24																																		25																																	26																																		27																																				28																																			29																												30																																			31																																	32																																			33																																34																																		35																																						36																													37																																	38																																		39																																	40																																		41																																			42																															43																																			44																																	45
global DEmptySlotPixelInfo := "0x4C3000x423y80:0x4C3000x428y83:0x4C3000x426y87:0x4C3000x424y84|0x4C3000x447y81:0x4C3000x452y81:0x4C3000x452y86:0x4C3000x448y86|0x4C3000x474y78:0x4C3000x479y83:0x4C3000x477y83:0x4C3000x474y86|0x4C3000x501y78:0x4C3000x502y83:0x4C3000x498y84:0x4C3000x503y87|0x4C3000x526y79:0x4C3000x531y81:0x4C3000x528y86:0x4C3000x524y84|0x4C3000x426y103:0x4C3000x430y108:0x4C3000x426y111:0x4C3000x421y109|0x4C3000x449y104:0x4C3000x453y104:0x4C3000x451y110:0x4C3000x447y110|0x4C3000x477y102:0x4C3000x477y105:0x4C3000x477y108:0x4C3000x477y113|0x4C3000x501y103:0x4C3000x501y105:0x4C3000x501y108:0x4C3000x501y111|0x4C3000x526y104:0x4C3000x526y107:0x4C3000x526y110:0x4C3000x527y113|0x4C3000x426y126:0x4C3000x426y130:0x4C3000x426y132:0x4C3000x426y135|0x4C3000x451y126:0x4C3000x451y127:0x4C3000x451y130:0x4C3000x451y132|0x4C3000x475y125:0x4C3000x475y130:0x4C3000x477y129:0x4C3000x475y134:0x4C3000x477y135:0x4C3000x473y133|0x4C3000x501y125:0x4C3000x501y128:0x4C3000x501y131:0x4C3000x501y135|0x4C3000x527y125:0x4C3000x527y127:0x4C3000x527y130:0x4C3000x527y132|0x4C3000x425y151:0x4C3000x425y154:0x4C3000x425y157:0x4C3000x425y159|0x4C3000x451y151:0x4C3000x451y154:0x4C3000x450y158:0x4C3000x448y159|0x4C3000x475y150:0x4C3000x475y154:0x4C3000x475y157:0x4C3000x475y161|0x4C3000x501y148:0x4C3000x501y152:0x4C3000x501y155:0x4C3000x500y158|0x4C3000x527y151:0x4C3000x527y154:0x4C3000x527y158:0x4C3000x524y159|0x4C3000x426y175:0x4C3000x426y179:0x4C3000x426y182:0x4C3000x424y184|0x4C3000x450y175:0x4C3000x448y176:0x4C3000x449y178:0x4C3000x449y184|0x4C3000x476y175:0x4C3000x476y178:0x4C3000x476y182:0x4C3000x473y184|0x4C3000x501y175:0x4C3000x501y178:0x4C3000x501y182:0x4C3000x498y185|0x4C3000x527y175:0x4C3000x527y178:0x4C3000x527y182:0x4C3000x525y182|0x4C3000x426y199:0x4C3000x426y201:0x4C3000x426y205:0x4C3000x426y208|0x4C3000x450y198:0x4C3000x450y201:0x4C3000x450y205:0x4C3000x448y209|0x4C3000x476y199:0x4C3000x476y201:0x4C3000x475y203:0x4C3000x473y208|0x4C3000x500y199:0x4C3000x500y204:0x4C3000x498y208:0x4C3000x503y206|0x4C3000x527y199:0x4C3000x527y203:0x4C3000x527y208:0x4C3000x523y204|0x4C3000x426y224:0x4C3000x426y226:0x4C3000x426y229:0x4C3000x424y233|0x4C3000x449y224:0x4C3000x449y228:0x4C3000x453y229:0x4C3000x450y232|0x4C3000x473y224:0x4C3000x477y226:0x4C3000x475y228:0x4C3000x475y232|0x4C3000x502y224:0x4C3000x502y228:0x4C3000x500y232:0x4C3000x498y233|0x4C3000x526y225:0x4C3000x526y228:0x4C3000x531y228:0x4C3000x528y232|0x4C3000x426y248:0x4C3000x426y250:0x4C3000x424y256:0x4C3000x429y254|0x4C3000x450y248:0x4C3000x450y250:0x4C3000x450y253:0x4C3000x448y257|0x4C3000x475y248:0x4C3000x475y250:0x4C3000x477y255:0x4C3000x482y253|0x4C3000x500y248:0x4C3000x500y250:0x4C3000x500y253:0x4C3000x503y255|0x4C3000x527y247:0x4C3000x527y249:0x4C3000x527y252:0x4C3000x527y256|0x4C3000x426y273:0x4C3000x426y276:0x4C3000x426y277:0x4C3000x426y280|0x4C3000x450y273:0x4C3000x448y276:0x4C3000x452y279:0x4C3000x448y279|0x4C3000x476y273:0x4C3000x476y276:0x4C3000x476y282:0x4C3000x474y278|0x4C3000x501y273:0x4C3000x501y276:0x4C3000x501y280:0x4C3000x498y282|0x4C3000x527y273:0x4C3000x527y277:0x4C3000x527y280:0x4C3000x526y282"
Global DDropCoords := "x174-374y53-322"
Global DMoveWindowTo00 := 1
OnMessage(0x4a, "Receive_WM_COPYDATA")  ; 0x4a is WM_COPYDATA This is for getting date set from external program aka bootdrop uses it.
OnMessage(0x200, "WM_MOUSEMOVE") ; Used for mouse over of image to display tooltip.
OnMessage(0x204, "WM_RBUTTONDOWN")

IniRead, ConfigVersion, %A_ScriptDir%/%IniFile%, NFB Config Version, Version
If (ConfigVersion <> Version) 
 FileDelete, %A_ScriptDir%/%IniFile%
;SplashImage, %FolderPathToResources%/splash.png, B CWFF00FF, , , loading
;WinSet, TransColor, FF00FF, loading

	;Ini Settings load.
IfNotExist, %A_ScriptDir%/%IniFile%
	{
		;Default Settings.
		IniWrite, %Version%, %A_ScriptDir%/%IniFile%, NFB Config Version, Version
		
		IniWrite, %DUpdateURL%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, UpdateURL
		IniWrite, %DLastUpdated%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LastUpdated
		
		IniWrite, %DFAddress%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, Pointer
		IniWrite, %DWaterOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, WaterOffset
		IniWrite, %DChocoOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, ChocoOffset
		IniWrite, %DLavaOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LavaOffset
		IniWrite, %DPlasmaOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, PlasmaOffset
		IniWrite, %DStateWaterOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateWaterOffset
		IniWrite, %DStateChocoOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateChocoOffset
		IniWrite, %DStateLavaOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateLavaOffset
		IniWrite, %DStatePlasmaOffset%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StatePlasmaOffset
		
		IniWrite, %DRecastWaitTime%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RecastWaitTime
		IniWrite, %DReelinWaitTime%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, ReelinWaitTime ;1.4.1
		IniWrite, %DMemoryScanStart%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, MemoryScanStart
		IniWrite, %DMemoryScanTimer%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, MemoryScanTimer
		
		IniWrite, %DRetryTimes%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimes
		IniWrite, %DRetryTimesBeforeStoping%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimesBeforeStoping
		IniWrite, %DAFKCloseCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, AFKCloseCheck

		IniWrite, %DBootDropAfterXSecondsCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSecondsCheck
		IniWrite, %DBootDropAfterXSeconds%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSeconds
		IniWrite, %DBootDropAfterXCastsCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCastsCheck
		IniWrite, %DBootDropAfterXCasts%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCasts
		IniWrite, %DBootDropAfterXFishingNotDetectedCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetectedCheck
		IniWrite, %DBootDropAfterXFishingNotDetected%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetected
		IniWrite, %DBootDropTimeout%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropTimeout
		IniWrite, %DDecon%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, Decon

		IniWrite, %DWhichSlotsToDrop%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, WhichSlotsToDrop
		IniWrite, %DEmptySlotPixelInfo%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, EmptySlotPixelInfo
		IniWrite, %DDropCoords%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, DropCoords
		IniWrite, %DMoveWindowTo00%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, MoveWindowTo00
		
			DefaultHotkeysList :=  ["Numpad1", "^Numpad1", "Numpad3", "^Numpad3", "Numpad2", "^Numpad2", "Numpad5", "NumpadMult", "Numpad4"]
			Loop, 9 {
			HKNumString := a_index
			HKDefaultKey := DefaultHotkeysList[a_index]
			Gui, HotKeyGUI:Default
			GuiControl,HotKeyGUI:,HK%HKNumString%,% HK%HKNumString% := HKDefaultKey
			setHK(HKNumString, savedHK%HKNumString%, HK%HKNumString%, 1)
	  	}
		
		MsgBox, % "SINCE THIS IS THE FRIST TIME IT HAS BEEN RAN PLEASE READ THE WHOLE THING BEFORE HITTING THE OK BUTTON!!!!!`n`nPlease make sure to hit NumberPad5 to make sure you have the newest pointers/offsets. `n`nIf you have any other questions please feel free ask them on the newest thread for Nippy's Fish Bot on MPGH.net under Trove.`n`nAnd please I beg of you Fish responsibly. HEHE Don't say I did not warn you.`n`nRemember if you like what you are using please hit that donate button and donate a little to the cause. It keeps me wanting to keep it updated week after week."
	}
SplashImageGUI(FolderPathToResources "/splash.png", "Center", "Center", 6000, true)
IniRead, UpdateURL, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, UpdateURL
IniRead, LastUpdated, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LastUpdated
IniRead, FAddress, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, Pointer
IniRead, WaterOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, WaterOffset
IniRead, LavaOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LavaOffset
IniRead, ChocoOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, ChocoOffset
IniRead, PlasmaOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, PlasmaOffset
IniRead, StateWaterOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateWaterOffset
IniRead, StateChocoOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateChocoOffset
IniRead, StateLavaOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateLavaOffset
IniRead, StatePlasmaOffset, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StatePlasmaOffset
IniRead, RecastWaitTime, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RecastWaitTime
IniRead, ReelinWaitTime, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, ReelinWaitTime
IniRead, MemoryScanStart, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, MemoryScanStart
IniRead, MemoryScanTimer, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, MemoryScanTimer
IniRead, RetryTimes, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimes
IniRead, RetryTimesBeforeStoping, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimesBeforeStoping
IniRead, AFKCloseCheck , %A_ScriptDir%/%IniFile%, Nippys Fish Bot, AFKCloseCheck
IniRead, BootDropAfterXSecondsCheck, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSecondsCheck
IniRead, BootDropAfterXSeconds, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSeconds
IniRead, BootDropAfterXCastsCheck, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCastsCheck
IniRead, BootDropAfterXCasts, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCasts
IniRead, BootDropAfterXFishingNotDetectedCheck, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetectedCheck
IniRead, BootDropAfterXFishingNotDetected, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetected
IniRead, BootDropTimeout, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropTimeout
IniRead, Decon, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, Decon
IniRead, WhichSlotsToDrop, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, WhichSlotsToDrop
IniRead, EmptySlotPixelInfo, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, EmptySlotPixelInfo
IniRead, DropCoords, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, DropCoords
IniRead, MoveWindowTo00, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, MoveWindowTo00
global SlotConfigList := StrSplit(WhichSlotsToDrop , "|")

;InitialSetup so it does not get ran again. Its not neded but make it look more pro.
;Making sure it is ran as admin.
If NOT A_IsAdmin
	{
		Run *RunAs "%A_ScriptFullPath%"
		ExitApp
	}

IfNotExist, %FolderPathToResources%
	{
		MsgBox, The resource folder path`n`n"%FolderPathToResources%"`n`n is not found please correct the problem and Run it again.`n`n If you are Running it from a archive or temp folder please extract the whole thing.
		ExitApp
	}

Process, Exist, TeamViewer.exe
  If (ErrorLevel)
    Msgbox, % "Teamviewer is currenly running. This is a known program to cause issues with the fishbot. Please close it or disable quick connect feature. If issues still happen try to uninstall it."

SetTimer, ActiveClientScan, 5000
;Starts Memory Scan/Recast buffer.
FishBiteMemoryScanToggle := !FishBiteMemoryScanToggle
SetTimer, FishBiteMemoryScan, %MemoryScanTimer%
SetTimer, Recast, 2000 ;v1.2 Changed the recast tigger form 4000 to 2000
;Triger afk check every 60secs. v1.2
SetTimer, Anti-AFK, 60000
SetTimer, InfoUpdate, 1000 ;v1.2 Gui update timer


If (ShowGui) {
		;Building Menus and GUI
		Menu, Tray, NoStandard
		Menu, Tray, Add, ShowUI, ShowUIL
		Menu, Tray, Add, Exit, FBGUIGuiClose
		;Menu, Tray, Default, Exit
		Menu, Tray, Icon, %A_ScriptDir%\Resources\icon.ico, 1

		;Main UI
		Gui, FBGui:Add, ListView, x12 y9 w670 h100 vFBListView Grid NoSortHdr -LV0x10 -LV0x8000 , Client pID|Fishing active?|Fishing start time|Last cast time|Liquid type|Reelin(Caught)|Recasts|Anti-Afk
		Gui, FBGui:Add, Button, x12 y119 w190 h20 gStartSelected, Start/Restart Selected Client
		Gui, FBGui:Add, Button, x212 y119 w180 h20 gStopSelected, Stop Selected Client
		Gui, FBGui:Add, Button, x12 y139 w190 h20 gStartAllClients, Start/Restart All Clients
		Gui, FBGui:Add, Button, x212 y139 w180 h20 gStopAllClients, Stop All Clients
		Gui, FBGui:Add, Button, x402 y119 w170 h20 gWipeClientList, Wipe all client data
		Gui, FBGui:Add, Button, x402 y139 w170 h20 gBringSelectedToForeground, Bring selected client to foregound
		Gui, FBGui:Add, Button, x582 y119 w100 h20 gConfigGUIShow, Config
		Gui, FBGui:Add, Button, x582 y139 w100 h20 gDonate, Donate
		ReAlignFB_LV()

		;Config UI
		Gui, FBConfig:-MaximizeBox -MinimizeBox -Disabled
		Gui, FBConfig:Font, S8 CDefault, Verdana
		Gui, FBConfig:Add, GroupBox, x2 y9 w390 h190 , Fishing Bot Config
		Gui, FBConfig:Add, Text, x23 y31 w90 h20 , Base Address:
		Gui, FBConfig:Add, Edit, x112 y29 w140 h20 vFAddress, %FAddress%
		Gui, FBConfig:Add, Text, x22 y61 w120 h20 , Wait time for recast:

		WaitTime := StrSplit(RecastWaitTime, "-")
		Gui, FBConfig:Add, Edit, x142 y59 w60 h20 vRecastWaitTimeEdit1, % WaitTime[1]
		Gui, FBConfig:Font, S15 CDefault, Verdana
		Gui, FBConfig:Add, Text, x202 y54 w20 h30 +Center, -
		Gui, FBConfig:Font, S8 CDefault, Verdana
		Gui, FBConfig:Add, Edit, x222 y59 w60 h20 vRecastWaitTimeEdit2, % WaitTime[2]

		Gui, FBConfig:Add, Text, x22 y91 w140 h20 , Time before scan starts:
		Gui, FBConfig:Add, Edit, x162 y89 w60 h20 vMemoryScanStart, %MemoryScanStart%
		Gui, FBConfig:Add, Text, x222 y91 w50 h20 , Seconds
		Gui, FBConfig:Add, GroupBox, x12 y109 w380 h90 , Error Handling
		Gui, FBConfig:Add, Text, x22 y131 w80 h20 , Retry times:
		Gui, FBConfig:Add, Edit, x102 y129 w70 h20 vRetryTimes, %RetryTimes%
		Gui, FBConfig:Add, Text, x22 y151 w130 h20 , Auto Afk/Close times:
		Gui, FBConfig:Add, Edit, x152 y149 w70 h20 vRetryTimesBeforeStoping, %RetryTimesBeforeStoping%
		Gui, FBConfig:Add, Checkbox, x22 y169 w270 h20 vAFKCloseCheck, Check for Auto Afk. UnCheck for Auto Close
		Gui, FBConfig:Add, GroupBox, x2 y199 w390 h140 , BootDrop
		Gui, FBConfig:Add, Checkbox, x22 y219 w140 h20 vBootDropAfterXSecondsCheck, Auto Boot drop after
		Gui, FBConfig:Add, Edit, x162 y219 w60 h20 vBootDropAfterXSeconds, %BootDropAfterXSeconds%
		Gui, FBConfig:Add, Text, x225 y221 w50 h20 , Seconds
		Gui, FBConfig:Add, Checkbox, x22 y239 w140 h20 vBootDropAfterXCastsCheck, Auto Boot drop after
		Gui, FBConfig:Add, Edit, x162 y239 w60 h20 vBootDropAfterXCasts, %BootDropAfterXCasts%
		Gui, FBConfig:Add, Text, x225 y241 w40 h20 , casts.
		Gui, FBConfig:Add, Checkbox, x22 y259 w140 h20 vBootDropAfterXFishingNotDetectedCheck, Auto Boot drop after
		Gui, FBConfig:Add, Edit, x162 y259 w60 h20 vBootDropAfterXFishingNotDetected, %BootDropAfterXFishingNotDetected%
		Gui, FBConfig:Add, Text, x225 y261 w160 h20 , times not fishing detected.
		Gui, FBConfig:Add, Text, x42 y291 w50 h20 , Timeout:
		Gui, FBConfig:Add, Edit, x102 y289 w70 h20 vBootDropTimeout, %BootDropTimeout%
		Gui, FBConfig:Add, Text, x175 y291 w50 h20 , Seconds.
		Gui, FBConfig:Add, Button, x22 y309 w200 h20 gBootDropConfigGuiToggle, Slot selection config show
		Gui, FBConfig:Add, Button, x2 y339 w195 h30 gConfigGUIShow, Save and Close config
		Gui, FBConfig:Add, Button, x+0 w195 h30 gHotKeyGUIShow, Custom Hotkeys ;gDefaultHotkeys
		Gui, FBConfig:Add, Picture, x259 y31 w16 h16 vHelp1 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x287 y62 w16 h16 vHelp2 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x277 y91 w16 h16 vHelp3 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x179 y132 w16 h16 vHelp4 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x227 y151 w16 h16 vHelp5 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x294 y173 w16 h16 vHelp6 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x272 y221 w16 h16 vHelp7 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x258 y240 w16 h16 vHelp8 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x375 y261 w16 h16 vHelp9 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x226 y291 w16 h16 vHelp10 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x226 y311 w16 h16 vHelp11 gHelp, %FolderPathToResources%helpIconSmall.png
		Gui, FBConfig:Add, Picture, x322 y291 w16 h16 vHelp12 gHelp, %FolderPathToResources%helpIconSmall.png
    Gui, FBConfig:Add, CheckBox, x262 y289 w60 h20 vDecon, Decon?
		Gui, FBConfig:Show, Hide Center h369 w393, Nippy's Fish Bot Config

		;Checking to see if the checkboxes are checked or not.
		If (AFKCloseCheck)
				GuiControl, FBConfig:, AFKCloseCheck, 1
		If (BootDropAfterXSecondsCheck)
				GuiControl, FBConfig:, BootDropAfterXSecondsCheck, 1
		If (BootDropAfterXCastsCheck)
				GuiControl, FBConfig:, BootDropAfterXCastsCheck, 1
		If (BootDropAfterXFishingNotDetectedCheck)
				GuiControl, FBConfig:, BootDropAfterXFishingNotDetectedCheck, 1
    If (Decon)
				GuiControl, FBConfig:, Decon, 1

		;Inventory selection GUI for Bootdrop.
		Gui, BootDropConfig:-MaximizeBox -MinimizeBox -Disabled
		Gui, BootDropConfig:Add, Picture, x1 y1 w160 h313 , %FolderPathToSlotConfigImages%InventoryCutout.bmp
		Gui, BootDropConfig:Add, Picture, x20 y34 w20 h20 gSlot1, %FolderPathToSlotConfigImages%1.bmp
		Gui, BootDropConfig:Add, Picture, x20 y34 w20 h20 gSlot1 BackgRoundTrans vSlot1, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y34 w20 h20 gSlot2, %FolderPathToSlotConfigImages%2.bmp
		Gui, BootDropConfig:Add, Picture, x45 y34 w20 h20 gSlot2 BackgRoundTrans vSlot2, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y34 w20 h20 gSlot3, %FolderPathToSlotConfigImages%3.bmp
		Gui, BootDropConfig:Add, Picture, x70 y34 w20 h20 gSlot3 BackgRoundTrans vSlot3, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y34 w20 h20 gSlot4, %FolderPathToSlotConfigImages%4.bmp
		Gui, BootDropConfig:Add, Picture, x95 y34 w20 h20 gSlot4 BackgRoundTrans vSlot4, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y34 w20 h20 gSlot5, %FolderPathToSlotConfigImages%5.bmp
		Gui, BootDropConfig:Add, Picture, x121 y34 w20 h20 gSlot5 BackgRoundTrans vSlot5, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y58 w20 h20 gSlot6, %FolderPathToSlotConfigImages%6.bmp
		Gui, BootDropConfig:Add, Picture, x20 y58 w20 h20 gSlot6 BackgRoundTrans vSlot6, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y58 w20 h20 gSlot7, %FolderPathToSlotConfigImages%7.bmp
		Gui, BootDropConfig:Add, Picture, x45 y58 w20 h20 gSlot7 BackgRoundTrans vSlot7, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y58 w20 h20 gSlot8, %FolderPathToSlotConfigImages%8.bmp
		Gui, BootDropConfig:Add, Picture, x70 y58 w20 h20 gSlot8 BackgRoundTrans vSlot8, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y58 w20 h20 gSlot9, %FolderPathToSlotConfigImages%9.bmp
		Gui, BootDropConfig:Add, Picture, x95 y58 w20 h20 gSlot9 BackgRoundTrans vSlot9, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y58 w20 h20 gSlot10, %FolderPathToSlotConfigImages%10.bmp
		Gui, BootDropConfig:Add, Picture, x121 y58 w20 h20 gSlot10 BackgRoundTrans vSlot10, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y82 w20 h20 gSlot11, %FolderPathToSlotConfigImages%11.bmp
		Gui, BootDropConfig:Add, Picture, x20 y82 w20 h20 gSlot11 BackgRoundTrans vSlot11, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y82 w20 h20 gSlot12, %FolderPathToSlotConfigImages%12.bmp
		Gui, BootDropConfig:Add, Picture, x45 y82 w20 h20 gSlot12 BackgRoundTrans vSlot12, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y82 w20 h20 gSlot13, %FolderPathToSlotConfigImages%13.bmp
		Gui, BootDropConfig:Add, Picture, x70 y82 w20 h20 gSlot13 BackgRoundTrans vSlot13, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y82 w20 h20 gSlot14, %FolderPathToSlotConfigImages%14.bmp
		Gui, BootDropConfig:Add, Picture, x95 y82 w20 h20 gSlot14 BackgRoundTrans vSlot14, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y82 w20 h20 gSlot15, %FolderPathToSlotConfigImages%15.bmp
		Gui, BootDropConfig:Add, Picture, x121 y82 w20 h20 gSlot15 BackgRoundTrans vSlot15, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y107 w20 h20 gSlot16, %FolderPathToSlotConfigImages%16.bmp
		Gui, BootDropConfig:Add, Picture, x20 y107 w20 h20 gSlot16 BackgRoundTrans vSlot16, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y107 w20 h20 gSlot17, %FolderPathToSlotConfigImages%17.bmp
		Gui, BootDropConfig:Add, Picture, x45 y107 w20 h20 gSlot17 BackgRoundTrans vSlot17, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y107 w20 h20 gSlot18, %FolderPathToSlotConfigImages%18.bmp
		Gui, BootDropConfig:Add, Picture, x70 y107 w20 h20 gSlot18 BackgRoundTrans vSlot18, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y107 w20 h20 gSlot19, %FolderPathToSlotConfigImages%19.bmp
		Gui, BootDropConfig:Add, Picture, x95 y107 w20 h20 gSlot19 BackgRoundTrans vSlot19, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y107 w20 h20 gSlot20, %FolderPathToSlotConfigImages%20.bmp
		Gui, BootDropConfig:Add, Picture, x121 y107 w20 h20 gSlot20 BackgRoundTrans vSlot20, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y131 w20 h20 gSlot21, %FolderPathToSlotConfigImages%21.bmp
		Gui, BootDropConfig:Add, Picture, x20 y131 w20 h20 gSlot21 BackgRoundTrans vSlot21, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y131 w20 h20 gSlot22, %FolderPathToSlotConfigImages%22.bmp
		Gui, BootDropConfig:Add, Picture, x45 y131 w20 h20 gSlot22 BackgRoundTrans vSlot22, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y131 w20 h20 gSlot23, %FolderPathToSlotConfigImages%23.bmp
		Gui, BootDropConfig:Add, Picture, x70 y131 w20 h20 gSlot23 BackgRoundTrans vSlot23, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y131 w20 h20 gSlot24, %FolderPathToSlotConfigImages%24.bmp
		Gui, BootDropConfig:Add, Picture, x95 y131 w20 h20 gSlot24 BackgRoundTrans vSlot24, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y131 w20 h20 gSlot25, %FolderPathToSlotConfigImages%25.bmp
		Gui, BootDropConfig:Add, Picture, x121 y131 w20 h20 gSlot25 BackgRoundTrans vSlot25, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y155 w20 h20 gSlot26, %FolderPathToSlotConfigImages%26.bmp
		Gui, BootDropConfig:Add, Picture, x20 y155 w20 h20 gSlot26 BackgRoundTrans vSlot26, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y155 w20 h20 gSlot27, %FolderPathToSlotConfigImages%27.bmp
		Gui, BootDropConfig:Add, Picture, x45 y155 w20 h20 gSlot27 BackgRoundTrans vSlot27, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y155 w20 h20 gSlot28, %FolderPathToSlotConfigImages%28.bmp
		Gui, BootDropConfig:Add, Picture, x70 y155 w20 h20 gSlot28 BackgRoundTrans vSlot28, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y155 w20 h20 gSlot29, %FolderPathToSlotConfigImages%29.bmp
		Gui, BootDropConfig:Add, Picture, x95 y155 w20 h20 gSlot29 BackgRoundTrans vSlot29, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y155 w20 h20 gSlot30, %FolderPathToSlotConfigImages%30.bmp
		Gui, BootDropConfig:Add, Picture, x121 y155 w20 h20 gSlot30 BackgRoundTrans vSlot30, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y180 w20 h20 gSlot31, %FolderPathToSlotConfigImages%31.bmp
		Gui, BootDropConfig:Add, Picture, x20 y180 w20 h20 gSlot31 BackgRoundTrans vSlot31, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y180 w20 h20 gSlot32, %FolderPathToSlotConfigImages%32.bmp
		Gui, BootDropConfig:Add, Picture, x45 y180 w20 h20 gSlot32 BackgRoundTrans vSlot32, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y180 w20 h20 gSlot33, %FolderPathToSlotConfigImages%33.bmp
		Gui, BootDropConfig:Add, Picture, x70 y180 w20 h20 gSlot33 BackgRoundTrans vSlot33, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y180 w20 h20 gSlot34, %FolderPathToSlotConfigImages%34.bmp
		Gui, BootDropConfig:Add, Picture, x95 y180 w20 h20 gSlot34 BackgRoundTrans vSlot34, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y180 w20 h20 gSlot35, %FolderPathToSlotConfigImages%35.bmp
		Gui, BootDropConfig:Add, Picture, x121 y180 w20 h20 gSlot35 BackgRoundTrans vSlot35, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y204 w20 h20 gSlot36, %FolderPathToSlotConfigImages%36.bmp
		Gui, BootDropConfig:Add, Picture, x20 y204 w20 h20 gSlot36 BackgRoundTrans vSlot36, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y204 w20 h20 gSlot37, %FolderPathToSlotConfigImages%37.bmp
		Gui, BootDropConfig:Add, Picture, x45 y204 w20 h20 gSlot37 BackgRoundTrans vSlot37, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y204 w20 h20 gSlot38, %FolderPathToSlotConfigImages%38.bmp
		Gui, BootDropConfig:Add, Picture, x70 y204 w20 h20 gSlot38 BackgRoundTrans vSlot38, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y204 w20 h20 gSlot39, %FolderPathToSlotConfigImages%39.bmp
		Gui, BootDropConfig:Add, Picture, x95 y204 w20 h20 gSlot39 BackgRoundTrans vSlot39, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y204 w20 h20 gSlot40, %FolderPathToSlotConfigImages%40.bmp
		Gui, BootDropConfig:Add, Picture, x121 y204 w20 h20 gSlot41 BackgRoundTrans vSlot40, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x20 y228 w20 h20 gSlot41, %FolderPathToSlotConfigImages%41.bmp
		Gui, BootDropConfig:Add, Picture, x20 y228 w20 h20 gSlot42 BackgRoundTrans vSlot41, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x45 y228 w20 h20 gSlot42, %FolderPathToSlotConfigImages%42.bmp
		Gui, BootDropConfig:Add, Picture, x45 y228 w20 h20 gSlot43 BackgRoundTrans vSlot42, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x70 y228 w20 h20 gSlot43, %FolderPathToSlotConfigImages%43.bmp
		Gui, BootDropConfig:Add, Picture, x70 y228 w20 h20 gSlot44 BackgRoundTrans vSlot43, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x95 y228 w20 h20 gSlot44, %FolderPathToSlotConfigImages%43.bmp
		Gui, BootDropConfig:Add, Picture, x95 y228 w20 h20 gSlot45 BackgRoundTrans vSlot44, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Picture, x121 y228 w20 h20 gSlot45, %FolderPathToSlotConfigImages%45.bmp
		Gui, BootDropConfig:Add, Picture, x121 y228 w20 h20 gSlot45 BackgRoundTrans vSlot45, %FolderPathToSlotConfigImages%tick.png
		Gui, BootDropConfig:Add, Text, x5 y316 w155 h28 , Click on each slot that you wish to Ignore on Boot Drop/Decon
		Gui, BootDropConfig:Add, Button, x2 y343 w157 h24 gBootDropConfigGuiClose, Save and Exit
		Gui, BootDropConfig:Show, Hide Center h370 w162, Boot Drop Config

    If (ShowDebug)
    Gui, DEBuginfo:Add, Edit, x12 y9 w440 h340 vMainInfo, DeBuginfo:
    If (ShowDebug)
    Gui, DEBuginfo:Show, x517 y269 h365 w463, Debutinfo Window:


		Loop, % SlotConfigList.MaxIndex() ;Scans the config file to see which ones to UnCheck as Checked is Default
			{
				SlotFlag := SubStr(SlotConfigList[a_index], 1 , 1)
				If (SlotFlag = 0)
					{
						Gui, BootDropConfig:Default
						GuiControl, hide , Slot%a_index%
					}
			}

	}

Gui, HotKeyGUI:-MaximizeBox -MinimizeBox -Disabled
	Gui, HotkeyGUI:Add, Text, xm-3 w260 h60, To set a hotkey just click on the text box and press the hotkey you want. You can hold CTRL,ALT,Shift as modifyers. Example CTRL+1 means that hotkey will be CTRL+1. You can also right click the hotkey to clear it.
#ctrls = 9  ;How many Hotkey controls to add.
Loop,% #ctrls {
 If (A_Index = 1)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+60 h20 w123, Start Fishing active client:
 If (A_Index = 2)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Start Fishing all clients:
 If (A_Index = 3)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Stop Fishing active client:
 If (A_Index = 4)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Stop Fishing all clients:
 If (A_Index = 5)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Toggle Afk on or off:
 If (A_Index = 6)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Turn on Afk all clients:
 If (A_Index = 7)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Pointer/Offset update:
 If (A_Index = 8)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Program Reload:
 If (A_Index = 9)
  Gui, HotKeyGUI:Add, Text, xm-3 yp+20 h20 w123, Show Debug info:	
  	

 IniRead, savedHK%A_Index%, NippysFishBot.ini, Hotkeys, %A_Index%, %A_Space%
 If savedHK%A_Index%                                       ;Check for saved hotkeys in INI file.
  Hotkey,% savedHK%A_Index%, HotKey%A_Index%                 ;Activate saved hotkeys if found.
 StringReplace, noMods, savedHK%A_Index%, ~                  ;Remove tilde (~) and Win (#) modifiers...
 StringReplace, noMods, noMods, #,,UseErrorLevel              ;They are incompatible with hotkey controls (cannot be shown).
 Gui, HotKeyGUI:Add, Hotkey, x+5 h18 vHK%A_Index% gSetHotKey, %noMods%           ;Add hotkey controls and show saved hotkeys.
 ;Gui, HotKeyGUI:Add, CheckBox, x+5 vCB%A_Index% Checked%ErrorLevel%, Win  ;Add checkboxes to allow the Windows key (#) as a modifier...
 Gui, HotKeyGUI:Add, Picture, x+5w16 h16 vHotkeyHelp%A_Index% gHelp, %FolderPathToResources%helpIconSmall.png
}                                                                ;Check the box if Win modifier is used.
Gui, HotKeyGUI:Add, Button, xm-3 yp+20 w135 h18 gHotKeyGUIClose, Save and Close
Gui, HotKeyGUI:Add, Button, x+0 w135 h18 gDefaultHotkeys, Default Hotkeys

ShowUIL:
	WinWaitClose, SplashImage
	Gui, FBGui:Show, Center h173 w700, Nippy's Fishing Bot
  FormatTime, CurrentDay,, dddd
  If (CurrentDay == "Wednesday") {
  	MsgBox, % "It is Wednesday today. This means that it is speed fishing day. So please check your Scan start time in the config by hitting the button in the lower right that says Config. Lower this setting from 12 to say 6. Other wise you might lose some fish."
  }
	Goto, ActiveClientScan
Return

FBGuiGuiSize:
GUI, FBGui:+Resize -MaximizeBox +MinSize690x163 +MaxSize690x 
Gui, FBGui:+LastFound
	WinGetPos X,Y,W,H
if A_EventInfo = 1 
    return
GuiControl, FBGui:Move, FBListView, % "W" . (W - 36) . " H" . (H - 95)
GuiControl, FBGui:Move, Start/Restart Selected Client, % "y" . (H - 83)
GuiControl, FBGui:Move, Start/Restart All Clients, % "y" . (H - 63)
GuiControl, FBGui:Move, Stop Selected Client, % "y" . (H - 83)
GuiControl, FBGui:Move, Stop All Clients, % "y" . (H - 63)
GuiControl, FBGui:Move, Wipe all client data, % "y" . (H - 83)
GuiControl, FBGui:Move, Bring selected client to foregound, % "y" . (H - 63)
GuiControl, FBGui:Move, Config, % "y" . (H - 83)
GuiControl, FBGui:Move, Donate, % "y" . (H - 63)
return

BootDropConfigGuiClose: ;To save and write the config file of the states that have been toggled.
	WhichSlotsToDrop :=
	Loop, % SlotConfigList.MaxIndex()
		{
			WhichSlotsToDrop .= SlotConfigList[a_index] "|"
		}
	IniWrite, %WhichSlotsToDrop%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, WhichSlotsToDrop
BootDropConfigGuiToggle:
	If !BootDropConfigWindowToggle {
			Gui, BootDropConfig:Show
	} Else {
			Gui, BootDropConfig:Hide
		}
	BootDropConfigWindowToggle := !BootDropConfigWindowToggle
Return

FBGUIGuiClose:
	MsgBox, 3,, Press Yes to Exit Nippy's Fishing bot.`nPress No to hide it to taskbar`nPress Cancel to do nothing.
	IfMsgBox Yes
			ExitApp
	Else IfMsgBox No
			Gui, FBGui:Hide
Return

HotKey8:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK8  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
 Reload
return

FBConfigGuiClose:
ConfigGUIShow:
	If !ConfigWindowToggle {

			Gui, FBConfig:Show
	} Else {
			;Gui, FBConfig:Hide
			Gui, FBConfig:Submit, hide
			IniWrite, %FAddress%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, Pointer
			RecastWaitTime := RecastWaitTimeEdit1 "-" RecastWaitTimeEdit2
			IniWrite, %RecastWaitTime%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RecastWaitTime

			IniWrite, %MemoryScanStart%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, MemoryScanStart
			IniWrite, %RetryTimes%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimes
			IniWrite, %RetryTimesBeforeStoping%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, RetryTimesBeforeStoping
			IniWrite, %AFKCloseCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot, AFKCloseCheck

			IniWrite, %BootDropAfterXSecondsCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSecondsCheck
			IniWrite, %BootDropAfterXSeconds%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXSeconds
			IniWrite, %BootDropAfterXCastsCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCastsCheck
			IniWrite, %BootDropAfterXCasts%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXCasts
			IniWrite, %BootDropAfterXFishingNotDetectedCheck%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetectedCheck
			IniWrite, %BootDropAfterXFishingNotDetected%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropAfterXFishingNotDetected
			IniWrite, %BootDropTimeout%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, BootDropTimeout
			IniWrite, %Decon%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, Decon

			;IniWrite, %WhichSlotsToDrop%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, WhichSlotsToDrop
			;IniWrite, %EmptySlotPixelInfo%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, EmptySlotPixelInfo
			;IniWrite, %DropCoords%, %A_ScriptDir%/%IniFile%, Nippys Fish Bot BD, DropCoords
		}
	ConfigWindowToggle := !ConfigWindowToggle
Return
;Pointer and offset updater
HotKey7:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK7  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
whr := ComObjCreate("WinHttp.WinHttpRequest.5.1")
whr.Open("GET", UpdateURL, true)
whr.Send()
whr.WaitForResponse()
;GrabbedInfo := whr.ResponseText
GrabbedInfo := StrSplit(whr.ResponseText , "|")

		IniWrite, % GrabbedInfo[2], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LastUpdated
		IniWrite, % GrabbedInfo[3], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, Pointer
		IniWrite, % GrabbedInfo[4], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, WaterOffset
		IniWrite, % GrabbedInfo[5], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, ChocoOffset
		IniWrite, % GrabbedInfo[6], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, LavaOffset
		IniWrite, % GrabbedInfo[7], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateWaterOffset
		IniWrite, % GrabbedInfo[8], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateChocoOffset
		IniWrite, % GrabbedInfo[9], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StateLavaOffset
		IniWrite, % GrabbedInfo[10], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, PlasmaOffset
		IniWrite, % GrabbedInfo[11], %A_ScriptDir%/%IniFile%, Nippys Fish Bot, StatePlasmaOffset
		
		Msgbox, % "The current Pointer/Offset was last set on:" LastUpdated "`nNewest Pointer/Offset was updated on:" GrabbedInfo[2] "`n`n*Newest Pointer/Offsets saved. The program will now reload."
		reload

;MsgBox % "Version: " GrabbedInfo[1] "`nLast Updated: " GrabbedInfo[2] "`nOffset: " GrabbedInfo[3] "`nWaterBiteOffset: " GrabbedInfo[4] "`nChocoBiteOffset: " GrabbedInfo[5] "`nLavaBiteOffset: " GrabbedInfo[6] "`nWaterLineInOffset: " GrabbedInfo[7] "`nChocoLineInOffset: " GrabbedInfo[8] "`nLavaLineInOffset: " GrabbedInfo[9]
Return


;Debugging stuff.
HotKey9:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK9  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
	Text =
	for index, element in BotList
	{
		Text .= "`n`nIndexMain:[" . index . "]`n"
		for index2, element2 in BotList[index]
		{
			Text .= "Index: [" . index2 . "] Element:[" . element2 . "]`n"
			for index3, element3 in BotList[index][index]
			{
				Text .= "Index: [" . index3 . "] of [" . index2 . "] Element:[" . element3 . "]`n"
			}
	}

}
ToolTipDisplay(Text)
Return

HotKey1:
 WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK1  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
} ;Sart and stop Fishing for active foreground client.
	;Getting the pID and Handle that is used for memory scans.
	WinGet, pidn, PID, A
	pID := pidn
	WinGet, hwnds, ID, A
	Handle := hwnds
StartSelected:
	If (A_GuiControlEvent)
		{
			pID := GetSelectedpID_FBListView() ;1.2.1 hotfix Changed up from a for to a loop it was ging wrong client info back.
			TotalClientsOnList := BotList.MaxIndex() ;1.2.1 hotfix Changed up from a for to a loop it was ging wrong client info back.
			Loop, %TotalClientsOnList% ;1.2.1 hotfix Changed up from a for to a loop it was ging wrong client info back.
				{
					If (BotList[a_index, 1] = pID)
							Handle := BotList[a_index, 2]

				}
		}
	;First cast also to detect liquid type.
	SendKeyFuction("f",pID,5,5)
	;Setting up addresses for Memory scan
	Base := getProcessBaseAddress(Handle)
	WaterAddress := GetAddress(pID, Base, FAddress, WaterOffset)
	LavaAddress := GetAddress(pID, Base, FAddress, LavaOffset)
	ChocoAddress := GetAddress(pID, Base, FAddress, ChocoOffset)
    PlasmaAddress := GetAddress(pID, Base, FAddress, PlasmaOffset)
	
	GetFishingStateWaterAddress := GetAddress(pID, Base, FAddress, StateWaterOffset)
	GetFishingStateLavaAddress := GetAddress(pID, Base, FAddress, StateLavaOffset)
	GetFishingStateChocoAddress := GetAddress(pID, Base, FAddress, StateChocoOffset)
	GetFishingStatePlasmaAddress := GetAddress(pID, Base, FAddress, StatePlasmaOffset)	
		
 Sleep 1200
	;Detecting Liquid type via memory read.
	DetectedLiquidType := 0 ;Default = for unknown type.
	If (ReadMemory(GetFishingStateWaterAddress,pID) = 1)
			DetectedLiquidType := 1
	Else If (ReadMemory(GetFishingStateLavaAddress,pID) = 1)
			DetectedLiquidType := 2
	Else If (ReadMemory(GetFishingStateChocoAddress,pID) = 1)
			DetectedLiquidType := 3
	Else If (ReadMemory(GetFishingStatePlasmaAddress,pID) = 1)
			DetectedLiquidType := 4

	;Updating Bot List with new info
	StartTime := a_now
	LastReelCast := a_now
	TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
	Loop, %TotalClientsOnList%
		{
			;Searching for pID match to know which bot to update with memory info.
			If (BotList[a_index, 1] = pID)
				{
					;BotList[a_index, 1] := pID                         ;These get added by auto detect client
					;BotList[a_index, 2] := Handle                      ;These get added by auto detect client
					BotList[a_index, 3] := Base
					BotList[a_index, 4] := WaterAddress
					BotList[a_index, 5] := LavaAddress
					BotList[a_index, 6] := ChocoAddress
					BotList[a_index, 7] := StartTime                        ;Started fishing time
					BotList[a_index, 8] := LastReelCast                        ;Last Cast time.
					BotList[a_index, 9] := GetFishingStateWaterAddress
					BotList[a_index, 10] := GetFishingStateLavaAddress
					BotList[a_index, 11] := GetFishingStateChocoAddress
					BotList[a_index, 12] := DetectedLiquidType
					BotList[a_index, 13] := 1                           ;Active Fishing
					BotList[a_index, 14] := 0                           ;Recast Counter
					BotList[a_index, 15] := 0                           ;Error Count
					;BotList[a_index, 16] := ClientDetectedTime         ;This gets added by auto detect client
					BotList[a_index, 17] := 0                           ;Total Reelin/caught
					BotList[a_index, 18] := 0                           ;Recast Counter to be used to tell if it is over using lures.
					BotList[a_index, 19] := 0                           ;Used to tell the Anti-AFK system if it can keep it form being afk.
					BotList[a_index, 20] := 0                           ;Used to tell the Anti-AFK system to tell when afk start.
					BotList[a_index, 21] := 0                           ;Does the client need a bootdrop 1 for on 0 for off
					BotList[a_index, 22] := 0                           ;Times casted for bootdrop trigering
					BotList[a_index, 23] := a_now                       ;Last time bootdrop started used for timeout reasons
					BotList[a_index, 24] := PlasmaAddress
					BotList[a_index, 25] := GetFishingStatePlasmaAddress
				}
		}
	If (DetectedLiquidType = 1) ;Water found scan only water type
			LiquidType = Water
	Else If (DetectedLiquidType = 2)	;Lava found scan only lava type
			LiquidType = Lava
	Else If (DetectedLiquidType = 3) ;Choco found only scan Choco type
			LiquidType = Chocolate
	Else If (DetectedLiquidType = 4) ;Plasma found only scan Plasma type
			LiquidType = Plasma
	Else
			LiquidType = Unknown

	If (ShowGui) ;v1.2 Updating LV Gui
		{
			ModifyFB_LVColBypID(pID, 2, "Yes")
			StartTime := BotList[index, 7]
			FormatTime, TimeString, StartTime, M/d/yyyy hh:mm:ss tt
			ModifyFB_LVColBypID(pID, 3, TimeString)
			ModifyFB_LVColBypID(pID, 4, "0")
			ModifyFB_LVColBypID(pID, 5, LiquidType)
			ModifyFB_LVColBypID(pID, 6, "0")
			ModifyFB_LVColBypID(pID, 7, "0")
			ModifyFB_LVColBypID(pID, 8, "Off")
		}
	TrayTipDisplay("This Client has started fishing.`npID: [" . pID . "] Liquid type: [" . LiquidType . "]")
Return

HotKey2:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK2  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
StartAllClients:
	TrayTipDisplay("Mass fishing started. Please wait...")
	Clientlist =
	WinGet, TroveList, List, ahk_exe trove.exe
	While TroveList%a_index%
	{
		WinGet, pID2, PID, % "ahk_id " TroveList%a_index%
		WinGet, Handle, ID, % "ahk_id " TroveList%a_index%
		;First cast also to detect liquid type.
		SendKeyFuction("f",pID2,5,5)
		
		;Setting up addresses for next scan.
		Base := getProcessBaseAddress(Handle)
	  WaterAddress := GetAddress(pID2, Base, FAddress, WaterOffset)
	  LavaAddress := GetAddress(pID2, Base, FAddress, LavaOffset)
	  ChocoAddress := GetAddress(pID2, Base, FAddress, ChocoOffset)
      PlasmaAddress := GetAddress(pID2, Base, FAddress, PlasmaOffset)
	  
  	GetFishingStateWaterAddress := GetAddress(pID2, Base, FAddress, StateWaterOffset)
  	GetFishingStateLavaAddress := GetAddress(pID2, Base, FAddress, StateLavaOffset)
  	GetFishingStateChocoAddress := GetAddress(pID2, Base, FAddress, StateChocoOffset)
	GetFishingStatePlasmaAddress := GetAddress(pID2, Base, FAddress, StatePlasmaOffset)
	
    Sleep 1200
		;Detecting Liquid type via memory read.
		DetectedLiquidType := 0 ;Default = for unknown type.

		If (ReadMemory(GetFishingStateWaterAddress,pID2) = 1)
				DetectedLiquidType := 1
		Else If (ReadMemory(GetFishingStateLavaAddress,pID2) = 1)
				DetectedLiquidType := 2
		Else If (ReadMemory(GetFishingStateChocoAddress,pID2) = 1)
				DetectedLiquidType := 3
		Else If (ReadMemory(GetFishingStatePlasmaAddress,pID2) = 1)
				DetectedLiquidType := 4

		;Updating Bot List with new info
		StartTime := a_now
		LastReelCast := a_now
		TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
		Loop, %TotalClientsOnList%
			{
				;Searching for pID match to know which bot to update with memory info.
				If (BotList[a_index, 1] = pID2)
					{
						;BotList[a_index, 1] := pID                         ;These get added by auto detect client
						;BotList[a_index, 2] := Handle                      ;These get added by auto detect client
						BotList[a_index, 3] := Base
						BotList[a_index, 4] := WaterAddress
						BotList[a_index, 5] := LavaAddress
						BotList[a_index, 6] := ChocoAddress
						BotList[a_index, 7] := StartTime                        ;Started fishing time
						BotList[a_index, 8] := LastReelCast                        ;Last Cast time.
						BotList[a_index, 9] := GetFishingStateWaterAddress
						BotList[a_index, 10] := GetFishingStateLavaAddress
						BotList[a_index, 11] := GetFishingStateChocoAddress
						BotList[a_index, 12] := DetectedLiquidType
						BotList[a_index, 13] := 1                           ;Active Fishing
						BotList[a_index, 14] := 0                           ;Recast Counter
						BotList[a_index, 15] := 0                           ;Error Count
						;BotList[a_index, 16] := ClientDetectedTime         ;This gets added by auto detect client
						BotList[a_index, 17] := 0                           ;Total Reelin/caught 
						BotList[a_index, 18] := 0                           ;Recast Counter to be used to tell if it is over using lures.
						BotList[a_index, 19] := 0                           ;Used to tell the Anti-AFK system if it can keep it form being afk.
						BotList[a_index, 20] := 0                           ;Used to tell the Anti-AFK system to tell when afk start.
						BotList[a_index, 21] := 0                           ;Does the client need a bootdrop 1 for on 0 for off
						BotList[a_index, 22] := 0                           ;Times casted for bootdrop trigering
						BotList[a_index, 23] := a_now                       ;Last time bootdrop started used for timeout reasons
						BotList[a_index, 24] := PlasmaAddress
					    BotList[a_index, 25] := GetFishingStatePlasmaAddress
					}
			}

		;This to change the detectedliqidtype from a number to the word for displaying
		If (DetectedLiquidType = 1) ;Water found scan only water type
				LiquidType = Water
		Else If (DetectedLiquidType = 2)	;Lava found scan only lava type
				LiquidType = Lava
		Else If (DetectedLiquidType = 3) ;Choco found only scan Choco type
				LiquidType = Chocolate
		Else If (DetectedLiquidType = 4) ;Plasma found only scan Plasma type
				LiquidType = Plasma
		Else
				LiquidType = Unknown
		If (ShowGui) ;v1.2 Updating LV Gui
			{
				ModifyFB_LVColBypID(pID2, 2, "Yes")
				FormatTime, TimeString, StartTime, M/d/yyyy hh:mm:ss tt
				ModifyFB_LVColBypID(pID2, 3, TimeString)
				ModifyFB_LVColBypID(pID2, 4, "0")
				ModifyFB_LVColBypID(pID2, 5, LiquidType)
				ModifyFB_LVColBypID(pID2, 6, "0")
				ModifyFB_LVColBypID(pID2, 7, "0")
				ModifyFB_LVColBypID(pID2, 8, "Off")
			}
		Clientlist .= "pID: [" . pID2 . "] Liquid type: [" . LiquidType . "]`n"
	}

TrayTipDisplay("Mass start fishing finshed.`n`nThe followling clients have started fishing.`n" . Clientlist)
Return

HotKey5:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK5  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
	WinGet, pidn, PID, A
	pID := pidn
	WinGet, hwnds, ID, A
	Handle := hwnds
	;Updating Bot List with info for afk toggle
	TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
	Loop, %TotalClientsOnList%
		{
			;Searching for pID match to know which bot to update with info.
			If (BotList[a_index, 1] = pID)
				{
					BotList[a_index, 19] := !BotList[a_index, 19] ;Toggle the Anti-afk 1 = on 0 being off. v1.2
					If(BotList[a_index, 19] = 1) {
					If (ShowGui)
							ModifyFB_LVColBypID(BotList[a_index, 1], 8, "On")
							TrayTipDisplay("Client on pID:["BotList[a_index, 1] "] AntiAfk turned On" )
					BotList[a_index, 20] := a_now
			} Else
					If(BotList[a_index, 19] = 0) {
			If (ShowGui)
					ModifyFB_LVColBypID(BotList[a_index, 1], 8, "Off")
					TrayTipDisplay("Client on pID:["BotList[a_index, 1] "] AntiAfk turned Off" )
			BotList[a_index, 20] := 0
		}
	}
}
Return

HotKey6:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK6  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
		TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
		Loop, %TotalClientsOnList%
			{
				;Searching for pID match to know which bot to update with info.
						BotList[a_index, 19] := 1 ;Toggle the Anti-afk 1 = on 0 being off.v1.2
						If (ShowGui)
								ModifyFB_LVColBypID(BotList[a_index, 1], 8, "On")
						BotList[a_index, 20] := a_now
						ToolTipDisplay("Anti-AFK On")
      }
Return



HotKey3:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK3  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
}
RemoveClient:
	;To remove active window from client list.
	WinGet, pidn, PID, A
	pID := pidn
	WinGet, hwnds, ID, A
	Handle := hwnds
StopSelected:
	If (A_GuiControlEvent)
		{
			pID := GetSelectedpID_FBListView()
			TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
			Loop, %TotalClientsOnList%
				{
					If (BotList[a_index, 1] = pID)
							Handle := BotList[a_index, 2]

				}
		}

	TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
	Loop, %TotalClientsOnList%
		{
			If (BotList[a_index, 1] = pID)
				{
					BotList[a_index, 13] := 0
					BotList[a_index, 14] := 0
					BotList[a_index, 15] := 0	
					BotList[a_index, 21] := 0
					BotList[a_index, 22] := 0
					BotList[a_index, 23] := 0
					;If (ShowGui) ;v1.2 Updating LV Gui
					;	{
					;		ModifyFB_LVColBypID(BotList[a_index, 1], 2, "No")
					;		ModifyFB_LVColBypID(BotList[a_index, 1], 3, "Not Fishing")
					;		ModifyFB_LVColBypID(BotList[a_index, 1], 4, "0")
					;		ModifyFB_LVColBypID(BotList[a_index, 1], 5, "Unknown")
					;	}
					TrayTipDisplay("This client has been deactivated from fishing.`nIndexID: [" . a_index . "] pID: [" . pid . "]")
					Return
				}
		}

	TrayTipDisplay("This client was not set to active fishing.`npID: [" . pid . "]")
Return

HotKey4:
	WinGetActiveTitle, ActiveTitle
 If (ActiveTitle = "Nippy's Fish Bot Hotkey Config") {
  Msgbox, % "This hotkey is already being used. Please clear the old one before setting a new one."
  Loop,6 
    {
     Gui, HotKeyGUI:Default
     GuiControl,% "Disable" b:=!b, HK4  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
Return
} ;v1.2
StopAllClients:
	TotalClientsOnList := BotList.MaxIndex() ;1.2.1 Hotfix. It would sometimes write to wrong bot in the array.
	Loop, %TotalClientsOnList%
		{
			BotList[a_index, 13] := 0
			BotList[a_index, 14] := 0
					BotList[a_index, 15] := 0	
					BotList[a_index, 21] := 0
					BotList[a_index, 22] := 0
					BotList[a_index, 23] := 0
			;If (ShowGui) ;v1.2 Updating LV Gui
			;	{
			;		ModifyFB_LVColBypID(BotList[a_index, 1], 2, "No")
			;		ModifyFB_LVColBypID(BotList[a_index, 1], 3, "Not Fishing")
			;		ModifyFB_LVColBypID(BotList[a_index, 1], 4, "0")
			;		ModifyFB_LVColBypID(BotList[a_index, 1], 5, "Unknown")
			;	}
		}
	TrayTipDisplay("Removed all clients from client the list." )
Return


+^NumPadSub::
	If !FishBiteMemoryScanToggle {
			SetTimer, FishBiteMemoryScan, 1000
			SetTimer, Recast, 2000
			SoundPlay, %A_WinDir%\Media\Windows Ding.wav
	} Else {
			SetTimer, FishBiteMemoryScan, Off
			SetTimer, Recast, Off
			SoundPlay, %A_WinDir%\Media\Windows Ding.wav
			Sleep 100
			SoundPlay, %A_WinDir%\Media\Windows Ding.wav
		}
	FishBiteMemoryScanToggle := !FishBiteMemoryScanToggle
Return

WipeClientList:
	Gui, FBGui:Default
	Gui, FBGui:ListView, FBListView
	LV_Delete()
	global BotList := Object()
Return

BringSelectedToForeground:
	ClientWindow := GetSelectedpID_FBListView()
	WinActivate, ahk_pid %ClientWindow% ;Brings the erroed client to the foregound.
Return

ActiveClientScan:
	WinGet, TroveList, List, ahk_exe trove.exe ;Scans all trove.exe files and adds to array
	While TroveList%a_index% ;Loops the array.
	{
		WinGet, pID, PID, % "ahk_id " TroveList%a_index%
		WinGet, Handle, ID, % "ahk_id " TroveList%a_index%
		If (pID = "" or Handle = "")
				Return

		TotalClientsOnList := BotList.MaxIndex() ;1.2.3 cleanup
		AddClient := 1

		Loop, %TotalClientsOnList%
			{
				If (BotList[a_index, 1] = pID) {
						AddClient := 0
					}
			}
		If (AddClient = 1) {
				;Adding bot to botlist array
				ClientDetectedTime := a_now
				Gui, FBGui:Default ;v1.2
				Gui, FBGui:ListView, FBListView ;v1.2
				lv_add("",pID,"No","Not Started","0","Unknown","0","0","Off") ;v1.2
				ReAlignFB_LV() ;v1.2
				LV_ModifyCol(1, "Sort")
				BotList.Insert(Array(pID ,Handle, "0", "0", "0", "0", "0", "0", "0", "0", "0" ,"0" ,"0", "0", "0" ,ClientDetectedTime,"0","0","0","0"))
				TotalClientsOnList := BotList.MaxIndex()
				TrayTipDisplay("New Trove client window found. Added the new client to the list.`n`nTotal Clients Detected:[" . TotalClientsOnList . "]") ;1.2.3
			}
	}

Return


InfoUpdate:
	TotalClientsOnList := BotList.MaxIndex()
	Loop, %TotalClientsOnList%
		{
			If(BotList[a_index, 13] = 0) ;1.4.6.3 BugFix Not updating if it had active fishing or not. My bad Did not notice till now.
					IsFishing := "No"
					Else
					IsFishing := "Yes"
					ModifyFB_LVColBypID(BotList[a_index, 1], 2, IsFishing)
			If (BotList[a_index, 13] = 1)
				{
					
					CastTime_LV1 :=
					CastTime_LV := BotList[a_index, 8]
					EnvSub, CastTime_LV1, CastTime_LV, Seconds

					ModifyFB_LVColBypID(BotList[a_index, 1], 4, CastTime_LV1)

					ModifyFB_LVColBypID(BotList[a_index, 1], 6, BotList[a_index, 17])
					ModifyFB_LVColBypID(BotList[a_index, 1], 7, BotList[a_index, 18])

				}
		}
Return

FishBiteMemoryScan:
	;StartScanTime := A_MSec + 0 ; Used for scan timing
	for index, element in BotList
	{
		;TotalClientsOnList := BotList.MaxIndex()
		;loop, %TotalClientsOnList%
		; {
		;index := a_index
		;WinID :=
		;Checking to make sure the next scan that the client is running. If not found it will auto remove form the list and move on to next.
		WinID := BotList[index, 2]
		;If (WinID = "")
		;    Return
		IfWinNotExist, ahk_id %WinID%
			{
				TrayTipDisplay("Client no longer found Removing.`nIndexID: [" . index . "] pID: [" . BotList[index, 1] . "]")
				DeleteFB_LVRowByPID(BotList[index, 1]) ;v1.2
				BotList.Remove(index)
				Return
			}

		;WinGetTitle, CurrentTitle, % "ahk_pid " BotList[index, 1] ;Lets get the current title name.
		;If (BotList[index, 13] = 1) ; Checking ot make sure the fishing flag and the recast flag are both set to 1 being on.
		;	{
				;Fishing is Active on pID
		;		NewTitle := "pID:[" . BotList[index, 1] . "] Fishing Active:[Yes]"
		;		If (NewTitle <> CurrentTitle)
		;				WinSetTitle, % "ahk_pid " BotList[index, 1], , % NewTitle
		;} Else {
				;Fishing is not active on pID
		;		NewTitle := "pID:[" . BotList[index, 1] . "] Fishing Active:[No]"
		;		If (NewTitle <> CurrentTitle)
		;				WinSetTitle, % "ahk_pid " BotList[index, 1], , % NewTitle ;v1.2 TitleFix
		;	}


		;Checking if bot the bot to make sure it has the active fish flag. If set 0 means it is not fishing. So returns to do next scan.
		If (BotList[index, 13] = 1 && BotList[index, 14] = 0)
			{
				;Checking last cast on record with currnet time.
				CurrentTime := ;v1.2 Fix for EnvSub not working First time.
				LastCastTime := BotList[index, 8]
				EnvSub, CurrentTime, LastCastTime, Seconds ;Converting last last cast time to Seconds.

				;Error handling to check to make sure it is still fishing.
				If (8< CurrentTime && CurrentTime < 11 or 45 < CurrentTime)
					{
						FishingState := "0"
						;Checking all 4 fishing states.
						CaughtFishingStateWater := ReadMemory(BotList[index, 9],BotList[index, 1])
						CaughtFishingStateLava := ReadMemory(BotList[index, 10],BotList[index, 1])
						CaughtFishingStateChoco := ReadMemory(BotList[index, 11],BotList[index, 1])
						CaughtFishingStatePlasma := ReadMemory(BotList[index, 25],BotList[index, 1])
							
            If (BotList[index, 12] = 0) {
            		If (CaughtFishingStateWater = 1) {
									LiquidType = Water
									DetectedLiquidType := 1
								  } Else If (CaughtFishingStateLava = 1) {
									LiquidType = Lava
									DetectedLiquidType := 2
								  } Else If (CaughtFishingStateChoco = 1) {
									LiquidType = Chocolate
									DetectedLiquidType := 3
								  } Else If (CaughtFishingStatePlasma = 1) {
									LiquidType = Plasma
									DetectedLiquidType := 4
								  } Else {
									LiquidType = Unknown
									DetectedLiquidType := 0
				          }
								BotList[index, 12] := DetectedLiquidType
								ModifyFB_LVColBypID(BotList[index, 1], 5, LiquidType)
            }

						;If fishing state = 1 ignores the error logging. 15
						If (CaughtFishingStateWater = 1 or CaughtFishingStateLava = 1 or CaughtFishingStateChoco = 1 or CaughtFishingStatePlasma = 1)
							{
								FishingState := "1"
								BotList[index, 15] := "0" ;Since fishing is detected it will wipe out the Error Count.
							}

						If (FishingState = 0)
							{
								If (BotList[index, 14] <> 1) { ;If recast is not 1 it trigers the Error Report.
										SetTimer, Recast, Off
										BotList[index, 15] := BotList[index, 15] + 1 ; Adds 1 for each time it is found not fishing. v1.2 Var Cleanup
										BotList[index, 14] := 1 ;Turning on the recast flag.
										SetTimer, Recast, 4000
										If (BotList[index, 15] > (RetryTimesBeforeStoping - 1)) ; Checking to see if it erros = 10+ if so automatic stop on tht client. ;1.3 Changes here and below
											{
												;Automatic Stop
												BotList[index, 13] := 0
												BotList[index, 14] := 0
												BotList[index, 15] := 0
												BotList[index, 19] := 1 ;Turning on AFK sstem for selcted acCount. v1.2 Added for Anti-afk
												If (AFKCloseCheck) {
														If (ShowGui)
																ModifyFB_LVColBypID(BotList[index, 1], 8, "On")
														BotList[index, 20] := a_now ;v1.2 Adding timestamp for when afk was turned on.
												} Else {
														Process, Close, % BotList[index, 1]
													}
												Notify("Fishing Error threshold has reached its limit. Going Afk or closing client out.")
												TrayTipDisplay("The client on index[" . index . "] pID[" . BotList[index, 1] . "] has had more than " . RetryTimesBeforeStoping . " Errors in a row. Automatic stop initiating. If Anti-Afk is Enabled it will be added to the list. Other wise it will Close the client out.") ;1.3
										} Else
												If (BotList[index, 15] > (RetryTimes -1))
													{
														Notify("Fishing Error has been detected. Attempting to retry.")
														Text := "The client on index[" . index . "] pID[" . BotList[index, 1] . "] seems to be not be fishing. Possible causes could be frozen client/character or full inventory or pointers need to be updated. Click this window to stop fishing on this client and bring the window to the foreground."
														TransSplashText_On("Error",Text,600,"Arial","Black",0,10,,,7000)
													}
									}
							}
					}

				;Memory scan for current client to check for fish bite
				If (MemoryScanStart < CurrentTime) ;Wont start a memory scan till 12Seconds has passed. This is to Lower cpu usage. v1.3 change to MemoryScanStart from 12
					{
						If (BotList[index, 12] = 1) ;Water type found scan only water type
								CaughtWater := ReadMemory(BotList[index, 4],BotList[index, 1])
						Else If (BotList[index, 12] = 2)	;Lava type found scan only lava type
								CaughtLava := ReadMemory(BotList[index, 5],BotList[index, 1])
						Else If (BotList[index, 12] = 3) ;Choco type found only scan Choco type
								CaughtChoco := ReadMemory(BotList[index, 6],BotList[index, 1])
						Else If (BotList[index, 12] = 4) ;Plasma type found only scan Plasma type
								CaughtPlasma := ReadMemory(BotList[index, 24],BotList[index, 1])
						Else {
								;Unknown type so we can all 3. This will use more cpu.
								CaughtWater := ReadMemory(BotList[index, 4],BotList[index, 1])
								CaughtLava := ReadMemory(BotList[index, 5],BotList[index, 1])
								CaughtChoco := ReadMemory(BotList[index, 6],BotList[index, 1])
								CaughtPlasma := ReadMemory(BotList[index, 24],BotList[index, 1])
							}
				} Else {
						CaughtWater := 0
						CaughtLava := 0
						CaughtChoco := 0
						CaughtPlasma := 0
					}

				;Preforming reelin
				If (CaughtWater = 1 or CaughtLava = 1 or CaughtChoco = 1 or CaughtPlasma = 1)
					{
						CaughtWater := 0
						CaughtLava := 0
						CaughtChoco := 0
						CaughtPlasma := 0
						;Checking to see if the bot is already recasting. And if so it will ignore below.
						If (BotList[index, 14] <> 1) {
								SetTimer, Recast, Off
								BotList[index, 8] := a_now
								BotList[index, 22] := BotList[index, 22] + 1 ;padding recast time for bd start detection
								BotList[index, 14] := 1   ;Turning on the recast flag.
								BotList[index, 17] := BotList[index, 17] + 1 ;Padding the reeled in Counter.
								SetTimer, Recast, 3000
								ReelinWaitTimeSplit := StrSplit(ReelinWaitTime, "-") 	;v1.4.1 Split the setting for Random time.
								SendKeyFuction("f",BotList[index, 1],ReelinWaitTimeSplit[1],ReelinWaitTimeSplit[2])
								If (ShowDebug)
								DADD("Reeling in on: " BotList[index, 1])
							}
					}
			}
	}
;Scan Timer
;StartScanTimeEnd := (A_MSec + 0) - StartScanTime
;ToolTipDisplay(StartScanTimeEnd)
Return

Recast:
	TotalClientsOnList := BotList.MaxIndex()
	Loop, %TotalClientsOnList%
		{
			If (BotList[a_index, 13] = 0)
			  GoTo, RecastEnd
			LastBDStartTimeInSeconds :=
			LastBDStartTime := BotList[a_index, 23]
			EnvSub, LastBDStartTimeInSeconds, LastBDStartTime, Seconds ;Converting last last cast time to Seconds.
			;BD dection flag.
			If(BootDropAfterXSecondsCheck = 1 && BootDropAfterXSeconds < LastBDStartTimeInSeconds)
			    BotList[a_index, 21] := 1 ;Turrning on flag for bootdrop.
			If (BootDropAfterXCastsCheck = 1 && BotList[a_index, 22] > BootDropAfterXCasts)
					BotList[a_index, 21] := 1 ;Turrning on flag for bootdrop.
			If (BootDropAfterXFishingNotDetectedCheck = 1 && BootDropAfterXFishingNotDetected < BotList[a_index, 15])
					BotList[a_index, 21] := 1 ;Turrning on flag for bootdrop.


      ;ToolTip, % "[" BootDropAfterXSecondsCheck "][" LastBDStartTimeInSeconds "]`n[" BootDropAfterXCastsCheck "][" BotList[a_index, 22] "]`n[" BootDropAfterXFishingNotDetectedCheck "][" BotList[a_index, 15] "]" , 1,1

			If (BotList[a_index, 21] = 1 && CheckToSeeIfBDRunning = 0 && BootDropTimeout < LastBDStartTimeInSeconds) ;CXhecking for the bootdrop flag onclient global Running and timeout. If found it will flag the acCount to do a bootdrop and not recast till finshed.
				{
					CheckToSeeIfBDRunning := 1 ;Setting global flag to 1 so it knows it is alReady Running the bootdrpo as you can not Run 2 at the same time.
					BotList[a_index, 19] := 1   ;Turning on afk
					BotList[a_index, 13] := 0 ;Turning off fishing for said client
					BotList[a_index, 21] := 0  ;turning off the flag as we are Running it not on said client.
					BotList[a_index, 22] := 0 ; reseting cast times
					BotList[a_index, 14] := 0 ; Turning off recast for this client as well so it wont cast.
					BotList[a_index, 23] := a_now  ;Setting new last ran bootdrop start on client.
					;This is where the bootdrop would run. %A_ScriptName%  %PathToBootDrop%
					Run, % PathToBootDrop " " A_ScriptName " " BotList[a_index, 1] " " Decon
					TrayTipDisplay("BD Trigered on " BotList[a_index, 1] " " LastBDStartTimeInSeconds)

				}
			If (BotList[a_index, 14] = 1) ; Checking ot make sure the fishing flag and the recast flag are both set to 1 being on. v1.2 Var clean up and timer changes.
				{
					BotList[a_index, 18] := BotList[a_index, 18] + 1 ;Pading the recast Count by 1
					WaitTime := StrSplit(RecastWaitTime, "-") 	;v1.2 Split the setting for Random time.
					SendKeyFuction("f",BotList[a_index, 1],WaitTime[1],WaitTime[2])
					BotList[a_index, 14] := "0"  ;Reseting the recast it recasted.
					BotList[a_index, 8] := a_now ;Setting the last cast time to current time.
				}
		RecastEnd:
		}
Return

;Anti-afk check v1.2 Added feature.
Anti-AFK:
	TotalClientsOnList := BotList.MaxIndex()
	Loop, %TotalClientsOnList%
		{
			If (BotList[a_index, 19] = 1) ; Checking ot make sure the fishing flag and the recast flag are both set to 1 being on.
				{
					SendKeyFuction("RCtrl",BotList[a_index, 1],5,5)
				}
				SetTimer, Anti-AFK, Off
				Random, rand, %AntiAFKRange1%, %AntiAFKRange2%
				SetTimer, Anti-AFK, %rand%
		}
Return

getProcessBaseAddress(Handle)
	{
		Return DllCall( A_PtrSize = 4
		? "GetWindowLong"
: "GetWindowLongPtr"
	        , "Ptr", Handle
	        , "Int", -6
	        , "Int64")
	}

GetAddress(PID, Base, Address, Offset)	{
		pointerBase := base + Address
		y := ReadMemory(pointerBase,PID)	
		OffsetSplit := StrSplit(Offset, "+")
		OffsetCount := OffsetSplit.MaxIndex()
	  Loop, %OffsetCount%
		{
			if (a_index = OffsetCount) {
			Address := (y + OffsetSplit[a_index])
	  	} Else
			if(a_index = 1) {
			y := ReadMemory(y + OffsetSplit[a_index],PID)
	  	} Else {
			y := ReadMemory(y + OffsetSplit[a_index],PID)
	 		 }
	 		 
	  }
Return Address
}

ReadMemory(MADDRESS, pid)	{
		VarSetCapacity(MVALUE,4,0)
		ProcessHandle := DllCall("OpenProcess", "Int", 24, "Char", 0, "UInt", pid, "UInt")
		DllCall("ReadProcessMemory", "UInt", ProcessHandle, "Ptr", MADDRESS, "Ptr", &MVALUE, "Uint",4)
		Loop 4
				result += *(&MVALUE + A_Index-1) << 8*(A_Index-1)
		Return, result
	}

RandSleep(x,y) {
		Random, rand, %x%, %y%
		Sleep %rand%
	}

TrayTipDisplay(Message) {
		TrayTip, Nippy's FishBot ,%Message%
		SetTimer, RemoveToolTip, 1000
		Return
	}
ToolTipDisplay(Message) {
		ToolTip, %Message%
		SetTimer, RemoveToolTip, 5000
		Return
	}
HelpDisplay(Message) {
		ToolTip, %Message%
		SetTimer, RemoveToolTip, 4000
		Return
	}
RemoveToolTip:
	SetTimer, RemoveToolTip, Off
	ToolTip
	TrayTip
Return
TransSplashText_On(Title="",Text="",Width="",Font="",TC="",SC="",TS="",xPos="",yPos="",TimeOut="") {
		TransSplashText_Off()
		If Title =
				Title = %A_ScriptName%
		If Text =
				Text = TransSplashText
		If Width =
				Width = 200
		If Font =
				Font = Impact
		If TC =
				TC = White
		If SC =
				SC = 828284
		If TS =
				TS = 20
		If xPos =
				xPos = Center
		If yPos =
				yPos = Center
		If TimeOut =
				TimeOut = 0
		If SC != 0
			{
				Gui, 99:Font, S%TS% C%SC%, %Font%
				Gui, 99:Add, Text, x7 y7 w%Width%, %Text%
			}
		Gui, 99:Font, S%TS% C%TC%, %Font%
		Gui, 99:Add, Text, x5 y5 w%Width% gGUITextClick, %Text%

		;Gui, 99:Color, EEAA99
		Gui, 99:+LastFound +AlwaysOnTop +ToolWindow ;-Caption
		;WinSet, TransColor, EEAA99
		Gui, 99:Show, x%xPos% y%yPos% AutoSize, %Title%
		If TimeOut != 0
			{
				SetTimer, TextOff, %TimeOut%
				Return
TextOff:
	TransSplashText_Off()
Return
}
}

GUITextClick:
	TransSplashText_Off() ;Turns off any active splash Screens.
	TotalClientsOnList := BotList.MaxIndex()
	Loop, %TotalClientsOnList%
		{
			If (1 < BotList[a_index, 15]) ;If client has any erors Counts it will automatic remove form active fishing when Gui is Clicked
				{
					ClientWindow := BotList[a_index, 2]
					WinActivate, ahk_id %ClientWindow% ;Brings the erroed client to the foregound.
					BotList[a_index, 13] := 0 ;Removing client from active scan list.
					BotList[a_index, 15] := 0 ;Resetting errot Count as it is no longer on the active list.
					BotList[a_index, 14] := 0 ;Removing Recast just incase. If it is activly fishing it wont try and recast lure.
					TrayTipDisplay("Removed client from active fishing list.`nIndexID: [" . a_index . "] pID: [" . BotList[a_index, 1] . "]")
				}
		}
Return

TransSplashText_Off() {
		Gui, 99:Destroy
		SetTimer, TextOff, Off
	}

GetSelectedpID_FBListView()
	{
		Gui, FBGui:Default
		Gui, FBGui:ListView, FBListView
		FocusedRowNumber := LV_GetNext(0, "F")  ; Find the Focused row.
		If not FocusedRowNumber  ; No row is Focused.
			{
				Return 0
			}
		LV_GetText(Text, LV_GetNext(RowNumber))

		Return Text
	}

DeleteFB_LVRowByPID(pID)
	{
		Gui, FBGui:Default
		Gui, FBGui:ListView, FBListView
		Loop % LV_GetCount()
			{
				LV_GetText(FBLV_pID, a_index, 1)
				If(FBLV_pID = pID) {
				LV_Delete(a_index)
			}
	}
}


ModifyFB_LVColBypID(pID,Column,Text)
	{
		Gui, FBGui:Default
		Gui, FBGui:ListView, FBListView
		Loop % LV_GetCount()
			{
				LV_GetText(FBLV_pID, a_index, 1)
				If(FBLV_pID = pID) {
				LV_GetText(CurrnetText, a_index, Column)
				If(CurrnetText != Text)
				LV_modify(a_index, "Col" Column, Text)
			}
	}
ReAlignFB_LV()
}

ReAlignFB_LV()
	{
		Gui, FBGui:Default
		Gui, FBGui:ListView, FBListView
		;LV_ModifyCol(1, "Integer")
		;LV_ModifyCol(1, "Sort")
		LV_ModifyCol(1, "AutoHdr")
		LV_ModifyCol(1, "Center")
		LV_ModifyCol(2, "AutoHdr")
		LV_ModifyCol(2, "Center")
		LV_ModifyCol(3, "AutoHdr")
		LV_ModifyCol(3, "Center")
		LV_ModifyCol(4, "AutoHdr")
		LV_ModifyCol(4, "Center")
		LV_ModifyCol(5, "AutoHdr")
		LV_ModifyCol(5, "Center")
		LV_ModifyCol(6, "AutoHdr")
		LV_ModifyCol(6, "Center")
		LV_ModifyCol(7, "AutoHdr")
		LV_ModifyCol(7, "Center")
		LV_ModifyCol(8, "60")
		LV_ModifyCol(8, "Center")
		Return
	}
Donate:
	Run, "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=VTDF4GT4HFYGU" , , Max  ;v1.2.2 Hotfix fixed the Button.
Return

ToggleImage(Slot)
	{

		SlotFlag := SubStr(SlotConfigList[Slot], 1 , 1)  ;State = Toggle state
		Yd := StrSplit(SlotConfigList[Slot] , "y") ;y[2] = Stored y coord.
		Xd := StrSplit(Yd[1] , "x") ;x[2] = x stored coord
		GuiControl, % ( SlotFlag:=!SlotFlag ) ? "show" : "hide", Slot%Slot%
		SlotConfigList[Slot] := SlotFlag "x" Xd[2] "y" Yd[2]
	}
Slot1:
	ToggleImage(1)
Return
Slot2:
	ToggleImage(2)
Return
Slot3:
	ToggleImage(3)
Return
Slot4:
	ToggleImage(4)
Return
Slot5:
	ToggleImage(5)
Return
Slot6:
	ToggleImage(6)
Return
Slot7:
	ToggleImage(7)
Return
Slot8:
	ToggleImage(8)
Return
Slot9:
	ToggleImage(9)
Return
Slot10:
	ToggleImage(10)
Return
Slot11:
	ToggleImage(11)
Return
Slot12:
	ToggleImage(12)
Return
Slot13:
	ToggleImage(13)
Return
Slot14:
	ToggleImage(14)
Return
Slot15:
	ToggleImage(15)
Return
Slot16:
	ToggleImage(16)
Return
Slot17:
	ToggleImage(17)
Return
Slot18:
	ToggleImage(18)
Return
Slot19:
	ToggleImage(19)
Return
Slot20:
	ToggleImage(20)
Return
Slot21:
	ToggleImage(21)
Return
Slot22:
	ToggleImage(22)
Return
Slot23:
	ToggleImage(23)
Return
Slot24:
	ToggleImage(24)
Return
Slot25:
	ToggleImage(25)
Return
Slot26:
	ToggleImage(26)
Return
Slot27:
	ToggleImage(27)
Return
Slot28:
	ToggleImage(28)
Return
Slot29:
	ToggleImage(29)
Return
Slot30:
	ToggleImage(30)
Return
Slot31:
	ToggleImage(31)
Return
Slot32:
	ToggleImage(32)
Return
Slot33:
	ToggleImage(33)
Return
Slot34:
	ToggleImage(34)
Return
Slot35:
	ToggleImage(35)
Return
Slot36:
	ToggleImage(36)
Return
Slot37:
	ToggleImage(37)
Return
Slot38:
	ToggleImage(38)
Return
Slot39:
	ToggleImage(39)
Return
Slot40:
	ToggleImage(40)
Return
Slot41:
	ToggleImage(41)
Return
Slot42:
	ToggleImage(42)
Return
Slot43:
	ToggleImage(43)
Return
Slot44:
	ToggleImage(44)
Return
Slot45:
	ToggleImage(45)
Return

Receive_WM_COPYDATA(wParam, lParam)
	{
		StringAddress := NumGet(lParam + 2*A_PtrSize)  ; Retrieves the CopyDataStruct's lpData member.
		CopyOfData := StrGet(StringAddress)  ; Copy the string out of the structure.
		; Show it with ToolTip vs. MsgBox so we can return in a timely fashion:
		;ToolTip %A_ScriptName%`nReceived the following string:`n%CopyOfData%
		Data := StrSplit(CopyOfData , ":")
		If (Data[1] = "BDFinished") {
				CheckToSeeIfBDRunning := 0

				TotalClientsOnList := BotList.MaxIndex() ;1.2.3 cleanup
				Loop, %TotalClientsOnList%
					{
						If (BotList[a_index, 1] = Data[2]) {
								BotList[a_index, 13] := 1  ;turning on fishing as bootdrop has finshed.
								BotList[a_index, 19] := 0   ;Turning off afk
							}
					}
				TrayTipDisplay("Bootdrop on the following client. pID: [" . Data[2] . "] has finshed in " Data[3] " Seconds.")
			}
		Return true  ; Returning 1 (true) is the traditional way to acknowledge this message.
	}

Help:
Return

WM_MOUSEMOVE() {
		If A_GuiControl = Help1
				HelpDisplay("This is the memory address that the bot uses for all its memory scaning.`nIf fishing liquid type is always unknown you might need to update this pointer. Check for forums for more info on what the new address might be.")
		Else If A_GuiControl = Help2
				HelpDisplay("This is used for the wait time Between reeling in and recasting. `nYou can set min and max. It will pick a Random Number Between the 2.")
		Else If A_GuiControl = Help3
				HelpDisplay("This is used for the memory scan. `nWhat it does is waits X amount of Seconds before starting the memory scan. This helps reduce cpu usage.")
		Else If A_GuiControl = Help4
				HelpDisplay("The Number of Retrys before poping up the Error Screen.")
		Else If A_GuiControl = Help5
				HelpDisplay("The Number of Retrys before stoping the fishing bot and adding it to the afk list or Close the client off.")
		Else If A_GuiControl = Help6
				HelpDisplay("Check the box to auto afk when Limit above is reached. `nUnCheck to Close the client out if Limit above is reached.")
		Else If A_GuiControl = Help7
				HelpDisplay("Check to start the auto bootdrop after X amount of Seconds.")
		Else If A_GuiControl = Help8
				HelpDisplay("Check to start the auto bootdrop after X amount of casts.")
		Else If A_GuiControl = Help9
				HelpDisplay("Check to start the auto bootdrop after X amount of failed fishing detections.")
		Else If A_GuiControl = Help10
				HelpDisplay("This is the timeout for the boot drop. `nSo it will not try and Run bootdrop on the same client within X amount of time.")
		Else If A_GuiControl = Help11
				HelpDisplay("Bootdrop slot selection.`nHere you will be able to tell the bot which slots you wish to Ignore. This way It wont try and drop that slot.")
		Else If A_GuiControl = Help12
				HelpDisplay("Check this if you wish to have it use the lootcollecter as well as boot drop. Other wise just leave unchecked for bootdrop only.")
		Else If A_GuiControl = HotKeyHelp1
				HelpDisplay("Sart Fishing for active client.")
		Else If A_GuiControl = HotkeyHelp2
				HelpDisplay("Start Fishing All clients.")
	  Else If A_GuiControl = HotkeyHelp3
				HelpDisplay("Stop Fishing Active client.")
	  Else If A_GuiControl = HotkeyHelp4
				HelpDisplay("Stop Fishing All clients.")
		Else If A_GuiControl = HotkeyHelp5
				HelpDisplay("Toggle the anti-afk on and off of active client.")
		Else If A_GuiControl = HotkeyHelp6
				HelpDisplay("Turns on anti-afk on all clients at the same time.")
		Else If A_GuiControl = HotkeyHelp7
				HelpDisplay("This will update pointers if I my self updated my webserver with newest pointers.")
		Else If A_GuiControl = HotkeyHelp8
				HelpDisplay("Reloads the whole program.")
		Else If A_GuiControl = HotkeyHelp9
				HelpDisplay("This is to display some debug info. Not needed for normal user.")
		;Else
		;	ToolTip
	}

WM_RBUTTONDOWN() {
If (InStr(A_GuiControl, "HK") == 1) {
	Gui, HotKeyGUI:Default
	StringTrimLeft, HKNumString, A_GuiControl, 2
	GuiControl,HotKeyGUI:,HK%HKNumString%,% HK%HKNumString% :=""
	setHK(HKNumString, savedHK%HKNumString%, HK%HKNumString%, 0)
}
}	
	
	
	SplashImageGUI(Picture, X, Y, Duration, Transparent = false)
{
Gui, XPT99:Margin , 0, 0
Gui, XPT99:Add, Picture,, %Picture%
Gui, XPT99:Color, ECE9D8
Gui, XPT99:+LastFound -Caption +AlwaysOnTop +ToolWindow -Border
If Transparent
{
Winset, TransColor, ECE9D8
}
Gui, XPT99:Show, x%X% y%Y% NoActivate, SplashImage
SetTimer, DestroySplashGUI, -%Duration%
return
}

DestroySplashGUI:
Gui, XPT99:Destroy
return


SetHotKey:
 If %A_GuiControl% in +,^,!,+^,+!,^!,+^!    ;If the hotkey contains only modifiers, return to wait for a key.
  return
 num := SubStr(A_GuiControl,3)              ;Get the index number of the hotkey control.
 If (HK%num% != "") {                       ;If the hotkey is not blank...
  Gui, HotKeyGUI:Submit, NoHide
  If CB%num%                                ;  If the 'Win' box is checked, then add its modifier (#).
   HK%num% := "#" HK%num%
  If !RegExMatch(HK%num%,"[#!\^\+]")        ;  If the new hotkey has no modifiers, add the (~) modifier.
   HK%num% := "" HK%num%                   ;    This prevents any key from being blocked.
  Loop,% #ctrls
   If (HK%num% = savedHK%A_Index%) {        ;  Check for duplicate hotkey...
    dup := A_Index
    Loop,6 
    {
     GuiControl,% "Disable" b:=!b, HK%dup%  ;    Flash the original hotkey to alert the user.
     Sleep,200
    }
    GuiControl,HotKeyGUI:,HK%num%,% HK%num% :=""      ;    Delete the hotkey and clear the control.
    break
   }
 }
 If (savedHK%num% || HK%num%)
  setHK(num, savedHK%num%, HK%num%, 0)
return

setHK(num,INI,GUI,MsgShow) {
 If INI
  Hotkey, %INI%, HotKey%num%, Off
 If GUI
  Hotkey, %GUI%, HotKey%num%, On
 IniWrite,% GUI ? GUI:null, NippysFishBot.ini, Hotkeys, %num%
 savedHK%num%  := HK%num%
 ;TrayTip, Label%num%,% !INI ? GUI " ON":!GUI ? INI " OFF":GUI " ON`n" INI " OFF"
 If (MsgShow = 1)
 return
 If (GUI = "") {
 	TrayTip, HotKey,% "Hotkey Is now cleared "
} Else {
 TrayTip, HotKey,% "Hotkey is now set to: " GUI
}
}

DefaultHotkeys:
	MsgBox, 4,,% "Do you wish to reset the hotkeys back to default?"
	IfMsgBox Yes
	{
	DefaultHotkeysList :=  ["Numpad1", "^Numpad1", "Numpad3", "^Numpad3", "Numpad2", "^Numpad2", "Numpad5", "NumpadMult", "Numpad4"]
	Loop,% #ctrls {
	HKNumString := a_index
	HKDefaultKey := DefaultHotkeysList[a_index]
	Gui, HotKeyGUI:Default
	GuiControl,HotKeyGUI:,HK%HKNumString%,% HK%HKNumString% := HKDefaultKey
	setHK(HKNumString, savedHK%HKNumString%, HK%HKNumString%, 1)
}
Msgbox, % "All hotkeys were reset back to default."
}
Return

HotKeyGUIClose:
HotKeyGUI:GuiClose:
 Gui, HotKeyGUI:Submit, Hide
Return

HotKeyGUIShow:
	Gui, HotKeyGUI:Show,,Nippy's Fish Bot Hotkey Config
Return

Notify(Message)
	{
		if (TTSEnabled = 0)
		  Return
		TTS(Voice, "Stop")
		TTS(Voice, "Speak", Message)
		Return
	}
	
SendKeyFuction(Key,pID,WaitTime1,WaitTime2)
{
        Random, rand, %WaitTime1%, %WaitTime2%
	    	Sleep %rand%
				ControlSend, , {%Key% down}, % "ahk_pid " pID
				Sleep 90
				ControlSend, , {%Key% up}, % "ahk_pid " pID
}
DADD(text)
{
	FormatTime, Time, a_now, M/d/yyyy hh:mm:ss tt

	gui, DebugInfo:submit, nohide
	Global MainInfo := MainInfo "`n[" Time "] " text
  guicontrol, DebugInfo:, MainInfo, %MainInfo%	
	
}